// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: accelfin-server-demo-fx-dtos.proto

package com.accelfin.server.demo.fx.dtos;

/**
 * Protobuf type {@code com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto}
 */
public  final class OrderBookUpdateResponseDto extends
    com.google.protobuf.GeneratedMessage implements
    // @@protoc_insertion_point(message_implements:com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto)
    OrderBookUpdateResponseDtoOrBuilder {
  // Use OrderBookUpdateResponseDto.newBuilder() to construct.
  private OrderBookUpdateResponseDto(com.google.protobuf.GeneratedMessage.Builder<?> builder) {
    super(builder);
  }
  private OrderBookUpdateResponseDto() {
    currencyPair_ = "";
    rungs_ = java.util.Collections.emptyList();
  }

  @java.lang.Override
  public final com.google.protobuf.UnknownFieldSet
  getUnknownFields() {
    return com.google.protobuf.UnknownFieldSet.getDefaultInstance();
  }
  private OrderBookUpdateResponseDto(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    this();
    int mutable_bitField0_ = 0;
    try {
      boolean done = false;
      while (!done) {
        int tag = input.readTag();
        switch (tag) {
          case 0:
            done = true;
            break;
          default: {
            if (!input.skipField(tag)) {
              done = true;
            }
            break;
          }
          case 10: {
            java.lang.String s = input.readStringRequireUtf8();

            currencyPair_ = s;
            break;
          }
          case 18: {
            if (!((mutable_bitField0_ & 0x00000002) == 0x00000002)) {
              rungs_ = new java.util.ArrayList<com.accelfin.server.demo.fx.dtos.OrderBookRungDto>();
              mutable_bitField0_ |= 0x00000002;
            }
            rungs_.add(input.readMessage(com.accelfin.server.demo.fx.dtos.OrderBookRungDto.parser(), extensionRegistry));
            break;
          }
        }
      }
    } catch (com.google.protobuf.InvalidProtocolBufferException e) {
      throw e.setUnfinishedMessage(this);
    } catch (java.io.IOException e) {
      throw new com.google.protobuf.InvalidProtocolBufferException(
          e).setUnfinishedMessage(this);
    } finally {
      if (((mutable_bitField0_ & 0x00000002) == 0x00000002)) {
        rungs_ = java.util.Collections.unmodifiableList(rungs_);
      }
      makeExtensionsImmutable();
    }
  }
  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return com.accelfin.server.demo.fx.dtos.AccelfinServerDemoFxDtos.internal_static_com_accelfin_server_demo_fx_dtos_OrderBookUpdateResponseDto_descriptor;
  }

  protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return com.accelfin.server.demo.fx.dtos.AccelfinServerDemoFxDtos.internal_static_com_accelfin_server_demo_fx_dtos_OrderBookUpdateResponseDto_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto.class, com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto.Builder.class);
  }

  private int bitField0_;
  public static final int CURRENCY_PAIR_FIELD_NUMBER = 1;
  private volatile java.lang.Object currencyPair_;
  /**
   * <code>optional string currency_pair = 1;</code>
   */
  public java.lang.String getCurrencyPair() {
    java.lang.Object ref = currencyPair_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = 
          (com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      currencyPair_ = s;
      return s;
    }
  }
  /**
   * <code>optional string currency_pair = 1;</code>
   */
  public com.google.protobuf.ByteString
      getCurrencyPairBytes() {
    java.lang.Object ref = currencyPair_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b = 
          com.google.protobuf.ByteString.copyFromUtf8(
              (java.lang.String) ref);
      currencyPair_ = b;
      return b;
    } else {
      return (com.google.protobuf.ByteString) ref;
    }
  }

  public static final int RUNGS_FIELD_NUMBER = 2;
  private java.util.List<com.accelfin.server.demo.fx.dtos.OrderBookRungDto> rungs_;
  /**
   * <code>repeated .com.accelfin.server.demo.fx.dtos.OrderBookRungDto rungs = 2;</code>
   */
  public java.util.List<com.accelfin.server.demo.fx.dtos.OrderBookRungDto> getRungsList() {
    return rungs_;
  }
  /**
   * <code>repeated .com.accelfin.server.demo.fx.dtos.OrderBookRungDto rungs = 2;</code>
   */
  public java.util.List<? extends com.accelfin.server.demo.fx.dtos.OrderBookRungDtoOrBuilder> 
      getRungsOrBuilderList() {
    return rungs_;
  }
  /**
   * <code>repeated .com.accelfin.server.demo.fx.dtos.OrderBookRungDto rungs = 2;</code>
   */
  public int getRungsCount() {
    return rungs_.size();
  }
  /**
   * <code>repeated .com.accelfin.server.demo.fx.dtos.OrderBookRungDto rungs = 2;</code>
   */
  public com.accelfin.server.demo.fx.dtos.OrderBookRungDto getRungs(int index) {
    return rungs_.get(index);
  }
  /**
   * <code>repeated .com.accelfin.server.demo.fx.dtos.OrderBookRungDto rungs = 2;</code>
   */
  public com.accelfin.server.demo.fx.dtos.OrderBookRungDtoOrBuilder getRungsOrBuilder(
      int index) {
    return rungs_.get(index);
  }

  private byte memoizedIsInitialized = -1;
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (!getCurrencyPairBytes().isEmpty()) {
      com.google.protobuf.GeneratedMessage.writeString(output, 1, currencyPair_);
    }
    for (int i = 0; i < rungs_.size(); i++) {
      output.writeMessage(2, rungs_.get(i));
    }
  }

  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (!getCurrencyPairBytes().isEmpty()) {
      size += com.google.protobuf.GeneratedMessage.computeStringSize(1, currencyPair_);
    }
    for (int i = 0; i < rungs_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, rungs_.get(i));
    }
    memoizedSize = size;
    return size;
  }

  private static final long serialVersionUID = 0L;
  public static com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input);
  }
  public static com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input);
  }
  public static com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessage
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessage.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * Protobuf type {@code com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessage.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto)
      com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDtoOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.accelfin.server.demo.fx.dtos.AccelfinServerDemoFxDtos.internal_static_com_accelfin_server_demo_fx_dtos_OrderBookUpdateResponseDto_descriptor;
    }

    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.accelfin.server.demo.fx.dtos.AccelfinServerDemoFxDtos.internal_static_com_accelfin_server_demo_fx_dtos_OrderBookUpdateResponseDto_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto.class, com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto.Builder.class);
    }

    // Construct using com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }
    private void maybeForceBuilderInitialization() {
      if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
        getRungsFieldBuilder();
      }
    }
    public Builder clear() {
      super.clear();
      currencyPair_ = "";

      if (rungsBuilder_ == null) {
        rungs_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000002);
      } else {
        rungsBuilder_.clear();
      }
      return this;
    }

    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return com.accelfin.server.demo.fx.dtos.AccelfinServerDemoFxDtos.internal_static_com_accelfin_server_demo_fx_dtos_OrderBookUpdateResponseDto_descriptor;
    }

    public com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto getDefaultInstanceForType() {
      return com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto.getDefaultInstance();
    }

    public com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto build() {
      com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    public com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto buildPartial() {
      com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto result = new com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto(this);
      int from_bitField0_ = bitField0_;
      int to_bitField0_ = 0;
      result.currencyPair_ = currencyPair_;
      if (rungsBuilder_ == null) {
        if (((bitField0_ & 0x00000002) == 0x00000002)) {
          rungs_ = java.util.Collections.unmodifiableList(rungs_);
          bitField0_ = (bitField0_ & ~0x00000002);
        }
        result.rungs_ = rungs_;
      } else {
        result.rungs_ = rungsBuilder_.build();
      }
      result.bitField0_ = to_bitField0_;
      onBuilt();
      return result;
    }

    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto) {
        return mergeFrom((com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto other) {
      if (other == com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto.getDefaultInstance()) return this;
      if (!other.getCurrencyPair().isEmpty()) {
        currencyPair_ = other.currencyPair_;
        onChanged();
      }
      if (rungsBuilder_ == null) {
        if (!other.rungs_.isEmpty()) {
          if (rungs_.isEmpty()) {
            rungs_ = other.rungs_;
            bitField0_ = (bitField0_ & ~0x00000002);
          } else {
            ensureRungsIsMutable();
            rungs_.addAll(other.rungs_);
          }
          onChanged();
        }
      } else {
        if (!other.rungs_.isEmpty()) {
          if (rungsBuilder_.isEmpty()) {
            rungsBuilder_.dispose();
            rungsBuilder_ = null;
            rungs_ = other.rungs_;
            bitField0_ = (bitField0_ & ~0x00000002);
            rungsBuilder_ = 
              com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders ?
                 getRungsFieldBuilder() : null;
          } else {
            rungsBuilder_.addAllMessages(other.rungs_);
          }
        }
      }
      onChanged();
      return this;
    }

    public final boolean isInitialized() {
      return true;
    }

    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto parsedMessage = null;
      try {
        parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        parsedMessage = (com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto) e.getUnfinishedMessage();
        throw e.unwrapIOException();
      } finally {
        if (parsedMessage != null) {
          mergeFrom(parsedMessage);
        }
      }
      return this;
    }
    private int bitField0_;

    private java.lang.Object currencyPair_ = "";
    /**
     * <code>optional string currency_pair = 1;</code>
     */
    public java.lang.String getCurrencyPair() {
      java.lang.Object ref = currencyPair_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        currencyPair_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     * <code>optional string currency_pair = 1;</code>
     */
    public com.google.protobuf.ByteString
        getCurrencyPairBytes() {
      java.lang.Object ref = currencyPair_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        currencyPair_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }
    /**
     * <code>optional string currency_pair = 1;</code>
     */
    public Builder setCurrencyPair(
        java.lang.String value) {
      if (value == null) {
    throw new NullPointerException();
  }
  
      currencyPair_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>optional string currency_pair = 1;</code>
     */
    public Builder clearCurrencyPair() {
      
      currencyPair_ = getDefaultInstance().getCurrencyPair();
      onChanged();
      return this;
    }
    /**
     * <code>optional string currency_pair = 1;</code>
     */
    public Builder setCurrencyPairBytes(
        com.google.protobuf.ByteString value) {
      if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
      
      currencyPair_ = value;
      onChanged();
      return this;
    }

    private java.util.List<com.accelfin.server.demo.fx.dtos.OrderBookRungDto> rungs_ =
      java.util.Collections.emptyList();
    private void ensureRungsIsMutable() {
      if (!((bitField0_ & 0x00000002) == 0x00000002)) {
        rungs_ = new java.util.ArrayList<com.accelfin.server.demo.fx.dtos.OrderBookRungDto>(rungs_);
        bitField0_ |= 0x00000002;
       }
    }

    private com.google.protobuf.RepeatedFieldBuilder<
        com.accelfin.server.demo.fx.dtos.OrderBookRungDto, com.accelfin.server.demo.fx.dtos.OrderBookRungDto.Builder, com.accelfin.server.demo.fx.dtos.OrderBookRungDtoOrBuilder> rungsBuilder_;

    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.OrderBookRungDto rungs = 2;</code>
     */
    public java.util.List<com.accelfin.server.demo.fx.dtos.OrderBookRungDto> getRungsList() {
      if (rungsBuilder_ == null) {
        return java.util.Collections.unmodifiableList(rungs_);
      } else {
        return rungsBuilder_.getMessageList();
      }
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.OrderBookRungDto rungs = 2;</code>
     */
    public int getRungsCount() {
      if (rungsBuilder_ == null) {
        return rungs_.size();
      } else {
        return rungsBuilder_.getCount();
      }
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.OrderBookRungDto rungs = 2;</code>
     */
    public com.accelfin.server.demo.fx.dtos.OrderBookRungDto getRungs(int index) {
      if (rungsBuilder_ == null) {
        return rungs_.get(index);
      } else {
        return rungsBuilder_.getMessage(index);
      }
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.OrderBookRungDto rungs = 2;</code>
     */
    public Builder setRungs(
        int index, com.accelfin.server.demo.fx.dtos.OrderBookRungDto value) {
      if (rungsBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureRungsIsMutable();
        rungs_.set(index, value);
        onChanged();
      } else {
        rungsBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.OrderBookRungDto rungs = 2;</code>
     */
    public Builder setRungs(
        int index, com.accelfin.server.demo.fx.dtos.OrderBookRungDto.Builder builderForValue) {
      if (rungsBuilder_ == null) {
        ensureRungsIsMutable();
        rungs_.set(index, builderForValue.build());
        onChanged();
      } else {
        rungsBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.OrderBookRungDto rungs = 2;</code>
     */
    public Builder addRungs(com.accelfin.server.demo.fx.dtos.OrderBookRungDto value) {
      if (rungsBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureRungsIsMutable();
        rungs_.add(value);
        onChanged();
      } else {
        rungsBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.OrderBookRungDto rungs = 2;</code>
     */
    public Builder addRungs(
        int index, com.accelfin.server.demo.fx.dtos.OrderBookRungDto value) {
      if (rungsBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureRungsIsMutable();
        rungs_.add(index, value);
        onChanged();
      } else {
        rungsBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.OrderBookRungDto rungs = 2;</code>
     */
    public Builder addRungs(
        com.accelfin.server.demo.fx.dtos.OrderBookRungDto.Builder builderForValue) {
      if (rungsBuilder_ == null) {
        ensureRungsIsMutable();
        rungs_.add(builderForValue.build());
        onChanged();
      } else {
        rungsBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.OrderBookRungDto rungs = 2;</code>
     */
    public Builder addRungs(
        int index, com.accelfin.server.demo.fx.dtos.OrderBookRungDto.Builder builderForValue) {
      if (rungsBuilder_ == null) {
        ensureRungsIsMutable();
        rungs_.add(index, builderForValue.build());
        onChanged();
      } else {
        rungsBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.OrderBookRungDto rungs = 2;</code>
     */
    public Builder addAllRungs(
        java.lang.Iterable<? extends com.accelfin.server.demo.fx.dtos.OrderBookRungDto> values) {
      if (rungsBuilder_ == null) {
        ensureRungsIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(
            values, rungs_);
        onChanged();
      } else {
        rungsBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.OrderBookRungDto rungs = 2;</code>
     */
    public Builder clearRungs() {
      if (rungsBuilder_ == null) {
        rungs_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000002);
        onChanged();
      } else {
        rungsBuilder_.clear();
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.OrderBookRungDto rungs = 2;</code>
     */
    public Builder removeRungs(int index) {
      if (rungsBuilder_ == null) {
        ensureRungsIsMutable();
        rungs_.remove(index);
        onChanged();
      } else {
        rungsBuilder_.remove(index);
      }
      return this;
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.OrderBookRungDto rungs = 2;</code>
     */
    public com.accelfin.server.demo.fx.dtos.OrderBookRungDto.Builder getRungsBuilder(
        int index) {
      return getRungsFieldBuilder().getBuilder(index);
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.OrderBookRungDto rungs = 2;</code>
     */
    public com.accelfin.server.demo.fx.dtos.OrderBookRungDtoOrBuilder getRungsOrBuilder(
        int index) {
      if (rungsBuilder_ == null) {
        return rungs_.get(index);  } else {
        return rungsBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.OrderBookRungDto rungs = 2;</code>
     */
    public java.util.List<? extends com.accelfin.server.demo.fx.dtos.OrderBookRungDtoOrBuilder> 
         getRungsOrBuilderList() {
      if (rungsBuilder_ != null) {
        return rungsBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(rungs_);
      }
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.OrderBookRungDto rungs = 2;</code>
     */
    public com.accelfin.server.demo.fx.dtos.OrderBookRungDto.Builder addRungsBuilder() {
      return getRungsFieldBuilder().addBuilder(
          com.accelfin.server.demo.fx.dtos.OrderBookRungDto.getDefaultInstance());
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.OrderBookRungDto rungs = 2;</code>
     */
    public com.accelfin.server.demo.fx.dtos.OrderBookRungDto.Builder addRungsBuilder(
        int index) {
      return getRungsFieldBuilder().addBuilder(
          index, com.accelfin.server.demo.fx.dtos.OrderBookRungDto.getDefaultInstance());
    }
    /**
     * <code>repeated .com.accelfin.server.demo.fx.dtos.OrderBookRungDto rungs = 2;</code>
     */
    public java.util.List<com.accelfin.server.demo.fx.dtos.OrderBookRungDto.Builder> 
         getRungsBuilderList() {
      return getRungsFieldBuilder().getBuilderList();
    }
    private com.google.protobuf.RepeatedFieldBuilder<
        com.accelfin.server.demo.fx.dtos.OrderBookRungDto, com.accelfin.server.demo.fx.dtos.OrderBookRungDto.Builder, com.accelfin.server.demo.fx.dtos.OrderBookRungDtoOrBuilder> 
        getRungsFieldBuilder() {
      if (rungsBuilder_ == null) {
        rungsBuilder_ = new com.google.protobuf.RepeatedFieldBuilder<
            com.accelfin.server.demo.fx.dtos.OrderBookRungDto, com.accelfin.server.demo.fx.dtos.OrderBookRungDto.Builder, com.accelfin.server.demo.fx.dtos.OrderBookRungDtoOrBuilder>(
                rungs_,
                ((bitField0_ & 0x00000002) == 0x00000002),
                getParentForChildren(),
                isClean());
        rungs_ = null;
      }
      return rungsBuilder_;
    }
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return this;
    }

    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return this;
    }


    // @@protoc_insertion_point(builder_scope:com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto)
  }

  // @@protoc_insertion_point(class_scope:com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto)
  private static final com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto();
  }

  public static com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<OrderBookUpdateResponseDto>
      PARSER = new com.google.protobuf.AbstractParser<OrderBookUpdateResponseDto>() {
    public OrderBookUpdateResponseDto parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
        return new OrderBookUpdateResponseDto(input, extensionRegistry);
    }
  };

  public static com.google.protobuf.Parser<OrderBookUpdateResponseDto> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<OrderBookUpdateResponseDto> getParserForType() {
    return PARSER;
  }

  public com.accelfin.server.demo.fx.dtos.OrderBookUpdateResponseDto getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

